//
//  UMTransportMessage.h
//  ulibtransport
//
//  Created by Andreas Fink on 07.06.18.
//  Copyright © 2018 Andreas Fink. All rights reserved.
//

#import <ulibasn1/ulibasn1.h>

#import <ulibtransport/UMTransportOpen.h>
#import <ulibtransport/UMTransportOpenAccept.h>
#import <ulibtransport/UMTransportOpenReject.h>
#import <ulibtransport/UMTransportClose.h>
#import <ulibtransport/UMTransportCloseAccept.h>
#import <ulibtransport/UMTransportRequest.h>
#import <ulibtransport/UMTransportResponse.h>
#import <ulibtransport/UMTransportNotification.h>
#import <ulibtransport/UMTransportAddress.h>


/*
     open goes with tcap_begin
     open accept goes with the first tcap continue
     open reject goes with tcap end
     close goes with tcap continue
     close accept goes with tcap end
     request goes with tcap continue
     response goes with tcap continue
     notification goes with tcap continue

    a tcap end is an implicit close if theres close payload or not
 */

@interface UMTransportMessage : UMASN1Choice
{
    NSInteger               _msgReference; /* from SMS or dialog ID on tcap */
    UMTransportAddress      *_src;
    UMTransportAddress      *_dst;
    UMTransportOpen         *_open;
    UMTransportOpenAccept   *_openAccept;
    UMTransportOpenReject   *_openReject;
    UMTransportClose        *_close;
    UMTransportCloseAccept  *_closeAccept;
    UMTransportRequest      *_request;
    UMTransportResponse     *_response;
    UMTransportNotification *_notification;
}


@property(readwrite,assign)  NSInteger               msgReference;
@property(readwrite,strong)  UMTransportAddress      *src;
@property(readwrite,strong)  UMTransportAddress      *dst;
@property(readwrite,strong)  UMTransportOpen         *open;
@property(readwrite,strong)  UMTransportOpenAccept   *openAccept;
@property(readwrite,strong)  UMTransportOpenReject   *openReject;
@property(readwrite,strong)  UMTransportClose        *close;
@property(readwrite,strong)  UMTransportCloseAccept  *closeAccept;
@property(readwrite,strong)  UMTransportRequest      *request;
@property(readwrite,strong)  UMTransportResponse     *response;
@property(readwrite,strong)  UMTransportNotification *notification;

@end
